Priority: Low Due date:  

Assignee:  % Done: 0%

Category: Database Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

I made a patch that adds support for firebird and RedDatabase(based on firebird).

Biggest problem that occurs when trying to run redmine with activerecord-fb-adapter that redmine uses in string constants firebird

keywords.

Associated revisions

Revision 16008 - 2016-11-28 06:54 - Toshi MARUYAMA

use symbol instead of string for 'position' (#24013)

Revision 16009 - 2016-11-28 07:21 - Toshi MARUYAMA

use symbol instead of string for 'position' in db migrate (#24013)

History

#1 - 2016-10-07 05:58 - Toshi MARUYAMA

It is too hard to see difference in patch.

Could you split patch to two patches?

1. only indent and white space change

2. main change

#2 - 2016-10-07 09:25 - Andrey Lobanov (RedSoft)

- File Fb_Support_clear.patch added

Here is clear patch. These small changes allows redmine work with firebird.

#3 - 2016-10-08 05:57 - Toshi MARUYAMA

Did you run tests and confirm other databases do not break tests?

http://www.redmine.org/builds/index.html

#4 - 2016-10-08 12:22 - Andrey Lobanov (RedSoft)

I'm sorry few tests failed. So i'll fix it and upload only fully working patch.

#5 - 2016-10-09 16:27 - Andrey Lobanov (RedSoft)

- File firebird_support_v2.patch added

New version of patch. Other dbs tests working.

#6 - 2016-10-09 19:34 - Toshi MARUYAMA

From blog written in Japanese:

http://qiita.com/jnchito/items/630b9f038c87298b5756

https://github.com/rails/rails/issues/16978#issuecomment-56211310

First thing, arel_table is private API of Rails and should not be used in applications.

 http://bikeshed.fm/74#comment-2830227073
In this podcast I heard Arel is going to be a public API in Rails 5.1, correct? Does that mean Rails developers will be allowed to use it in

applications?

 I got an answer from Sean:

Yes, it will be stable after 5.1

https://twitter.com/sgrif/status/763830491204026368

#7 - 2016-10-09 19:35 - Toshi MARUYAMA

- Tracker changed from Patch to Feature

- Priority changed from Normal to Low

#8 - 2016-10-09 19:37 - Andrey Lobanov (RedSoft)

Oh. I'll change arel_table usage.

#9 - 2016-10-10 18:11 - Andrey Lobanov (RedSoft)

- File Firebird_support_v3.patch added

Fixed arel_table usage.

#10 - 2016-10-23 08:44 - Mischa The Evil

For completeness' sake:

Upstream (activerecord-fb-adapter) issue: https://github.com/rowland/activerecord-fb-adapter/issues/70 (Problem with db migration)

Upstream pull request: https://github.com/rowland/activerecord-fb-adapter/pull/73 (Redmine support)

Note from quick visual patch scan: it seems it is missing adaptations to the Gemfile, the configuration stubs (config/database.yml.example) and the

documentation (doc/INSTALL) reflecting the proposed extension of DB support.

#11 - 2016-10-25 19:18 - Warren Postma

Given that Firebird is an extremely limited and feature-poor alternative to MySQL or Postgres, who would want to use Firebird? I say this as a person

with 10 years professional Firebird (and Interbase) experience.

Firebird is itself an open source fork of the Borland/Embarcadero Interbase product.

#12 - 2016-10-31 14:15 - Andrey Lobanov (RedSoft)

Warren Postma wrote:

Given that Firebird is an extremely limited and feature-poor alternative to MySQL or Postgres, who would want to use Firebird? I say this as a

person with 10 years professional Firebird (and Interbase) experience.

Firebird is itself an open source fork of the Borland/Embarcadero Interbase product.

 I'm sorry but when Firebird became feature-poor? Did you checked latest version 3.0?

#13 - 2016-11-28 14:06 - Toshi MARUYAMA

- File issue-24103-r16009-misc.diff added

- File issue-24103-r16009-keywords.diff added

- File issue-24103-r16009-db-migrate.diff added

These are patches which remained Firebird_support_v3.patch after r16008 and r16009.

I think issue-24013-r16009-db-migrate.diff breaks existing system.

#14 - 2016-11-28 14:14 - Toshi MARUYAMA

- File issue-24013-r16009-db-migrate.diff added

- File issue-24013-r16009-misc.diff added

- File issue-24013-r16009-keywords.diff added

Fixed issue number of patch files.

2025-05-02 2/4

https://twitter.com/sgrif/status/763830491204026368
https://github.com/rowland/activerecord-fb-adapter
https://github.com/rowland/activerecord-fb-adapter/issues/70
https://github.com/rowland/activerecord-fb-adapter/pull/73
https://www.redmine.org/attachments/16851
https://www.redmine.org/projects/redmine/repository/svn/revisions/16008
https://www.redmine.org/projects/redmine/repository/svn/revisions/16009
https://www.redmine.org/attachments/17145


#15 - 2016-11-28 14:14 - Toshi MARUYAMA

- File deleted (issue-24103-r16009-keywords.diff)

#16 - 2016-11-28 14:14 - Toshi MARUYAMA

- File deleted (issue-24103-r16009-misc.diff)

#17 - 2016-11-28 14:14 - Toshi MARUYAMA

- File deleted (issue-24103-r16009-db-migrate.diff)

#18 - 2017-01-12 14:16 - Andrey Lobanov (RedSoft)

Right now i'm trying to find better solution to support Firebird.

The biggest problem to make it looks native. Because of large count of hardcoded queries with Firebird's keywords.

#19 - 2017-01-20 15:53 - Andrey Lobanov (RedSoft)

Example of queries changes to fit firebird:

Before:

    JournalDetail.

      where(["property = 'attr' AND prop_key = 'assigned_to_id' AND value = ?", id.to_s]).

      update_all(['value = ?', substitute.id.to_s])

After:

    JournalDetail.

      where(:property => 'attr', :prop_key => 'assigned_to_id', :value => id.to_s).

      update_all(:value => substitute.id.to_s)

 Main problem is subqueries or part of queries(where, select, etc) like this:

      # Returns a JOIN clause that is added to the query when sorting by custom values

      def join_for_order_statement(custom_field)

        alias_name = join_alias(custom_field)

        "LEFT OUTER JOIN #{CustomValue.table_name} #{alias_name}" +

          " ON #{alias_name}.customized_type = '#{custom_field.class.customized_class.base_class.name}'" +

          " AND #{alias_name}.customized_id = #{custom_field.class.customized_class.table_name}.id" +

          " AND #{alias_name}.custom_field_id = #{custom_field.id}" +

          " AND (#{custom_field.visibility_by_project_condition})" +

          " AND #{alias_name}.value <> ''" +

          " AND #{alias_name}.id = (SELECT max(#{alias_name}_2.id) FROM #{CustomValue.table_name} #{alias_name

}_2" +

            " WHERE #{alias_name}_2.customized_type = #{alias_name}.customized_type" +

            " AND #{alias_name}_2.customized_id = #{alias_name}.customized_id" +

            " AND #{alias_name}_2.custom_field_id = #{alias_name}.custom_field_id)" 

      end

In this code fragment i can't find good solution to replace 

#{alias_name}.value

Any suggestions? I'll appreciate any help

#20 - 2017-01-23 14:23 - Andrey Lobanov (RedSoft)

- File current_trunk_Firebird_and_RedDatabase_support.patch added

Here changes to support firebird at actual trunk.

#21 - 2017-01-23 15:47 - Andrey Lobanov (RedSoft)

- File current_trunk_Decimal_data_type_fix.patch added

Also decimal precision fix

#22 - 2017-01-23 15:48 - Andrey Lobanov (RedSoft)
I think i forgot about some migration files. But i'll fix that later.

#23 - 2017-02-14 13:50 - Andrey Lobanov (RedSoft)

- File Symbols_instead_of_strings_to_support_firebird_keywords.patch added

Here some fixes to use symbols instead of strings.

#24 - 2017-02-14 13:54 - Andrey Lobanov (RedSoft)

- File Value_keyword_replaced_with_symbols__in_application_controller.patch added

Value keyword replaced in application_controller

#25 - 2019-10-18 02:31 - Lucas Schatz

Any news about this patch? is it stable? integrated?

It would be nice to use Firebird with Redmine too :)

Thanks!

#26 - 2022-05-20 16:17 - Tim Crawford

Warren Postma wrote:

Given that Firebird is an extremely limited and feature-poor alternative to MySQL or Postgres, who would want to use Firebird? I say this as a

person with 10 years professional Firebird (and Interbase) experience.

Firebird is itself an open source fork of the Borland/Embarcadero Interbase product.

 Just saw this. What?

Firebird is far better than MySql, especially for small systems.

MySql download alone is over 600 MB and takes about 30 minutes minumum to install

Firebird is 15 MB and can be installed in under 5 minutes

I says this as a person who worked for Oracle for 17 years,

and 7 years working with MySql and Firebird

Files

Basic_Fb_support.patch 41.8 KB 2016-10-06 Andrey Lobanov (RedSoft)

Fb_Support_clear.patch 31 KB 2016-10-07 Andrey Lobanov (RedSoft)

firebird_support_v2.patch 41.2 KB 2016-10-09 Andrey Lobanov (RedSoft)

Firebird_support_v3.patch 40.6 KB 2016-10-10 Andrey Lobanov (RedSoft)

issue-24013-r16009-misc.diff 18.3 KB 2016-11-28 Toshi MARUYAMA

issue-24013-r16009-db-migrate.diff 3.61 KB 2016-11-28 Toshi MARUYAMA

issue-24013-r16009-keywords.diff 10.7 KB 2016-11-28 Toshi MARUYAMA

current_trunk_Firebird_and_RedDatabase_support.patch 27.7 KB 2017-01-23 Andrey Lobanov (RedSoft)

current_trunk_Decimal_data_type_fix.patch 4.76 KB 2017-01-23 Andrey Lobanov (RedSoft)

Symbols_instead_of_strings_to_support_firebird_keywords.patch 5.95 KB 2017-02-14 Andrey Lobanov (RedSoft)

Value_keyword_replaced_with_symbols__in_application_controller.patch915 Bytes 2017-02-14 Andrey Lobanov (RedSoft)
